local _, _AG = ...
local L = _AG.L
_AG.UI = _AG.UI or {}
FantasyLootUI = _AG.UI

local statInfoToIndex = {
  ITEM_MOD_SPIRIT_SHORT           = 1,
  ITEM_MOD_DODGE_RATING_SHORT     = 2,
  ITEM_MOD_PARRY_RATING_SHORT     = 3,
  ITEM_MOD_HIT_RATING_SHORT       = 4,
  ITEM_MOD_CRIT_RATING_SHORT      = 5,
  ITEM_MOD_HASTE_RATING_SHORT     = 6,
  ITEM_MOD_EXPERTISE_RATING_SHORT = 7,
  ITEM_MOD_MASTERY_RATING_SHORT   = 8,
}
local indexToStatInfo = {
  "ITEM_MOD_SPIRIT_SHORT",
  "ITEM_MOD_DODGE_RATING_SHORT",
  "ITEM_MOD_PARRY_RATING_SHORT",
  "ITEM_MOD_HIT_RATING_SHORT",
  "ITEM_MOD_CRIT_RATING_SHORT",
  "ITEM_MOD_HASTE_RATING_SHORT",
  "ITEM_MOD_EXPERTISE_RATING_SHORT",
  "ITEM_MOD_MASTERY_RATING_SHORT",
}
local gemKeys = {
  EMPTY_SOCKET_BLUE = "Blue",
  EMPTY_SOCKET_COGWHEEL = "Cogwheel",
  EMPTY_SOCKET_HYDRAULIC = "Hydraulic",
  EMPTY_SOCKET_META = "Meta",
  EMPTY_SOCKET_NO_COLOR = "Prismatic",
  EMPTY_SOCKET_PRISMATIC = "Prismatic",
  EMPTY_SOCKET_RED = "Red",
  EMPTY_SOCKET_YELLOW = "Yellow",
}
local primaryGemTexture = "Interface\\ItemSocketingFrame\\UI-ItemSockets";
local engineeringGemTexture = "Interface\\ItemSocketingFrame\\UI-EngineeringSockets";

local GEM_TYPE_INFO = {};
GEM_TYPE_INFO["Yellow"] = {tex=primaryGemTexture, w=43, h=43, left=0, right=0.16796875, top=0.640625, bottom=0.80859375, r=0.97, g=0.82, b=0.29, CBx=53, CBy=53, CBLeft=0.5546875, CBRight=0.7578125, CBTop=0, CBBottom=0.20703125, OBx=61, OBy=57, OBLeft=0.7578125, OBRight=0.9921875, OBTop=0, OBBottom=0.22265625};
GEM_TYPE_INFO["Red"] = {tex=primaryGemTexture, w=43, h=43, left=0.1796875, right=0.34375, top=0.640625, bottom=0.80859375, r=1, g=0.47, b=0.47, CBx=53, CBy=53, CBLeft=0.5546875, CBRight=0.7578125, CBTop=0.4765625, CBBottom=0.68359375, OBx=61, OBy=57, OBLeft=0.7578125, OBRight=0.9921875, OBTop=0.4765625, OBBottom=0.69921875};
GEM_TYPE_INFO["Blue"] = {tex=primaryGemTexture, w=43, h=43, left=0.3515625, right=0.51953125, top=0.640625, bottom=0.80859375, r=0.47, g=0.67, b=1, CBx=53, CBy=53, CBLeft=0.5546875, CBRight=0.7578125, CBTop=0.23828125, CBBottom=0.4453125, OBx=61, OBy=57, OBLeft=0.7578125, OBRight=0.9921875, OBTop=0.23828125, OBBottom=0.4609375};
GEM_TYPE_INFO["Hydraulic"] = {tex=engineeringGemTexture, w=43, h=43, left=0.01562500, right=0.68750000, top=0.50000000, bottom=0.58398438, r=1, g=1, b=1, CBx=59, CBy=54, CBLeft=0.01562500, CBRight=0.93750000, CBTop=0.00195313, CBBottom=0.10742188, OBx=59, OBy=54, OBLeft=0.01562500, OBRight=0.93750000, OBTop=0.11132813, OBBottom=0.21679688};
GEM_TYPE_INFO["Cogwheel"] = {tex=engineeringGemTexture, w=43, h=43, left=0.01562500, right=0.68750000, top=0.41210938, bottom=0.49609375, r=1, g=1, b=1, CBx=49, CBy=47, CBLeft=0.01562500, CBRight=0.78125000, CBTop=0.22070313, CBBottom=0.31250000, OBx=49, OBy=47, OBLeft=0.01562500, OBRight=0.78125000, OBTop=0.31640625, OBBottom=0.40820313};
GEM_TYPE_INFO["Meta"] = {tex=primaryGemTexture, w=57, h=52, left=0.171875, right=0.3984375, top=0.40234375, bottom=0.609375, r=1, g=1, b=1, CBLeft=0.5546875, CBx=53, CBy=53, CBRight=0.7578125, CBTop=0, CBBottom=0.20703125, OBLeft=0.7578125, OBx=61, OBy=57, OBRight=0.9921875, OBTop=0, OBBottom=0.22265625};
GEM_TYPE_INFO["Prismatic"] = {tex=engineeringGemTexture, w=43, h=43, left=0.01562500, right=0.68750000, top=0.76367188, bottom=0.84765625, r=1, g=1, b=1, CBx=43, CBy=43, CBLeft=0.01562500, CBRight=0.68750000, CBTop=0.67578125, CBBottom=0.75976563, OBx=43, OBy=43, OBLeft=0.01562500, OBRight=0.68750000, OBTop=0.58789063, OBBottom=0.67187500};

-- Upgrade table
_AG.upgradeByType = _AG.upgradeByType or {
  [1] = "Valor t16", [2] = "Mystery t16", [3] = "Valor t15", [4] = "Mystery t15",
  [5] = "Valor t13/14", [6] = "Mystery t13/14", [7] = "Justice", [8] = "Conquest s12", [9] = "Honor s12",
  ["Valor t16"] = {levels = 4, [1] = {start = 491, levels = 2}, [2] = {start = 504, levels = 1}},
  ["Mystery t16"] = {levels = 6, [1] = {start = 494, levels = 4}, [2] = {start = 506, levels = 1}},
  ["Valor t15"] = {start = 465, levels = 2},
  ["Mystery t15"] = {start = 468, levels = 4},
  ["Valor t13/14"] = {start = 445, levels = 2},
  ["Mystery t13/14"] = {start = 458, levels = 4},
  ["Justice"] = {start = 451, levels = 1},
  ["Conquest s12"] = {start = 453, levels = 2},
  ["Honor s12"] = {start = 456, levels = 1},
}
local upgradeByType = _AG.upgradeByType

_AG.gemIndex = _AG.gemIndex or {
  "Red", "Blue", "Yellow", "Orange", "Green", "Purple", "Meta", "Legendary", "Cogwheel"
}
local gemIndex = _AG.gemIndex

function FantasyLootUI:Show()
	FantasyLootFrame:Show()
end

function FantasyLootUI:Hide()
	FantasyLootFrame:Hide()
end

local function DropDownInitialize( frame, level )
  local menuList = frame.menu
  for index = 1, #menuList do
    local value = menuList[index]
    if (value.text) then
      value.func = frame.SetValue
      value.checked = value.text == frame.selected
      UIDropDownMenu_AddButton( value, level );
    end
  end
end

local function DropDownSetValue(frame, arg1, arg2)
  local parent = select(2,select(2,frame:GetPoint()):GetPoint())
  parent.selected = frame.value
  UIDropDownMenu_SetText(parent, frame.value)
  FantasyLoot:DeltaApply(arg2, arg1)
  FantasyLootUI:DeltaUpdate(arg2, arg1)
end

local function GemDropDownSelect(frame, arg1)
  local gem = FantasyLootUI.lastGem or "gem1" -- shouldnt happen
  CloseDropDownMenus()
  FantasyLoot:DeltaApply(gem, arg1)
  FantasyLootUI:Update(FantasyLootFrame)
  FantasyLootFrame.FinishedGlow.FinishedAnim:Play()
end

local function GenerateGemMenu()
  local menu = {}
  for i,k in ipairs(gemIndex) do
    local submenu = {}
    for sk, sv in pairs(FantasyLoot.db.gemToStatsByType[k]) do
      tinsert(submenu, {text = sv.text, notCheckable = 1, arg1 = sk, func = GemDropDownSelect})
    end
    if #submenu > 0 then
      tinsert(menu, {text = L[k], notCheckable = 1, hasArrow = true, menuList = submenu})
    end
  end
  tinsert(menu, {text = L["Discover gems..."], notCheckable = 1, func = function()
    FantasyLoot:GenerateGemTable()
    FantasyLootUI.gemMenu = GenerateGemMenu()
    FantasyLootUI:Update(FantasyLootFrame)
  end})
  return menu
end

function FantasyLootUI:OnInitialize()
  FantasyLootUI.gemMenu = GenerateGemMenu()
  FantasyLootFrameStatusFrame.StatusText:SetText(FantasyLoot.db.gemsKnown..L[" gems discovered."])
end

function FantasyLootUI:OnLoad(frame)
  frame:RegisterForDrag("LeftButton")
	SetPortraitToTexture(FantasyLootFramePortrait, "Interface\\Icons\\Ability_Shaman_RepulsionTotem")
	FantasyLootFrameTitleText:SetText("FantasyLoot")
	FantasyLootFrameTopTileStreaks:Hide()
	FantasyLootFrameBg:Hide()
  frame.ItemButton.SubItemText:SetText(L["<Shift-Click To Link Item>"])
  
  -- Localized text
  FantasyLootFrame.MissingDescription:SetText(L["MAIN_FRAME_DESCRIPTION"])
  FantasyLootFrame.ItemButton.MissingText:SetText(L["MISSING_ITEM"])
  
  -- Build menus
  local prefix = "FantasyLootFrameControl"
  local index = 1
  -- Reforge
    -- Current (Reforge from)
    -- Reforge (Reforge to)
  local reforgeFrom = CreateFrame("FRAME", prefix..index, FantasyLootFrame, "FantasyLootControlTemplate")
  reforgeFrom:SetPoint("TOPLEFT", FantasyLootFrame.HorzBar, "TOPLEFT", 4, -7)
  reforgeFrom.Label:SetText(REFORGE_CURRENT)
  local reforgeFromDropDown = CreateFrame("FRAME", prefix..index.."DropDown", reforgeFrom, "UIDropDownMenuTemplate")
  reforgeFromDropDown:SetPoint("TOPLEFT", reforgeFrom, "TOPLEFT", -10, -15)
  UIDropDownMenu_SetWidth(reforgeFromDropDown, 110)
  reforgeFromDropDown.menu = {}
  reforgeFromDropDown.SetValue = DropDownSetValue
  UIDropDownMenu_Initialize(reforgeFromDropDown, DropDownInitialize)
  UIDropDownMenu_SetAnchor(reforgeFromDropDown, -12, 10, "TOPRIGHT", reforgeFromDropDown, "BOTTOMRIGHT")
  index = index + 1
  
  local reforgeTo = CreateFrame("FRAME", prefix..index, FantasyLootFrame, "FantasyLootControlTemplate")
  reforgeTo:SetPoint("TOP", reforgeFrom, "BOTTOM", 0, -1)
  reforgeTo.Label:SetText(REFORGE)
  local reforgeToDropDown = CreateFrame("FRAME", prefix..index.."DropDown", reforgeTo, "UIDropDownMenuTemplate")
  reforgeToDropDown:SetPoint("TOPLEFT", reforgeTo, "TOPLEFT", -10, -15)
  UIDropDownMenu_SetWidth(reforgeToDropDown, 110)
  reforgeToDropDown.menu = {}
  reforgeToDropDown.SetValue = DropDownSetValue
  UIDropDownMenu_Initialize(reforgeToDropDown, DropDownInitialize)
  UIDropDownMenu_SetAnchor(reforgeToDropDown, -12, 10, "TOPRIGHT", reforgeToDropDown, "BOTTOMRIGHT")
  index = index + 1
  
  -- Upgrade
    -- Upgrade type: [jp,vp,hp,cp,unk]
    -- Upgrade level: [0/2, 1/2, 2/2] etc
  local upgradeType = CreateFrame("FRAME", prefix..index, FantasyLootFrame, "FantasyLootControlTemplate")
  upgradeType:SetPoint("TOPRIGHT", FantasyLootFrame.HorzBar, "TOPRIGHT", -4, -7)
  upgradeType.Label:SetText(REFORGE_CURRENT)
  local upgradeTypeDropDown = CreateFrame("FRAME", prefix..index.."DropDown", upgradeType, "UIDropDownMenuTemplate")
  upgradeTypeDropDown:SetPoint("TOPLEFT", upgradeType, "TOPLEFT", -10, -15)
  UIDropDownMenu_SetWidth(upgradeTypeDropDown, 110)
  upgradeTypeDropDown.menu = {}
  upgradeTypeDropDown.SetValue = DropDownSetValue
  UIDropDownMenu_Initialize(upgradeTypeDropDown, DropDownInitialize)
  UIDropDownMenu_SetAnchor(upgradeTypeDropDown, -12, 10, "TOPRIGHT", upgradeTypeDropDown, "BOTTOMRIGHT")
  index = index + 1
  
  local upgradeLevel = CreateFrame("FRAME", prefix..index, FantasyLootFrame, "FantasyLootControlTemplate")
  upgradeLevel:SetPoint("TOP", upgradeType, "BOTTOM", 0, -1)
  upgradeLevel.Label:SetText(UPGRADE)
  local upgradeLevelDropDown = CreateFrame("FRAME", prefix..index.."DropDown", upgradeLevel, "UIDropDownMenuTemplate")
  upgradeLevelDropDown:SetPoint("TOPLEFT", upgradeLevel, "TOPLEFT", -10, -15)
  UIDropDownMenu_SetWidth(upgradeLevelDropDown, 110)
  upgradeLevelDropDown.menu = {}
  upgradeLevelDropDown.SetValue = DropDownSetValue
  UIDropDownMenu_Initialize(upgradeLevelDropDown, DropDownInitialize)
  UIDropDownMenu_SetAnchor(upgradeLevelDropDown, -12, 10, "TOPRIGHT", upgradeLevelDropDown, "BOTTOMRIGHT")
  index = index + 1
  
  -- Print enchants
  local enchantID = CreateFrame("FRAME", prefix..index, FantasyLootFrame, "FantasyLootControlTemplate")
  enchantID:SetPoint("TOPLEFT", FantasyLootFrame.HorzBar2, "TOPLEFT", 4, -7)
  enchantID.Label:SetText(L["Enchant ID"])
  local enchantIDInputBox = CreateFrame("EditBox", prefix..index.."InputBox", enchantID, "InputBoxTemplate")
  enchantIDInputBox:SetAutoFocus(false)
  enchantIDInputBox:SetPoint("TOPLEFT", enchantID, "TOPLEFT", 10, -17)
  enchantIDInputBox:SetWidth(64)
  enchantIDInputBox:SetHeight(16)
  enchantIDInputBox:SetNumeric(true)
  enchantIDInputBox:SetMaxLetters(6)
  enchantIDInputBox:SetScript("OnEnterPressed", function(frame)
    if frame:GetText() == "" then
      frame:SetText("0")
    end
    FantasyLoot:DeltaApply("enchantID",frame:GetText())
    if frame:GetText() ~= "0" then
      FantasyLootFrame.FinishedGlow.FinishedAnim:Play()
    end
    frame:ClearFocus()
  end)
  enchantIDInputBox:SetScript("OnTextChanged", function(frame)
    if frame:GetText() == "" then
      frame:SetText("0")
    end
    FantasyLootFrameControl5EnchantName:SetText(FantasyLoot:GetEnchantName(frame:GetText()))
  end)
  local enchantIDName = enchantID:CreateFontString(prefix..index.."EnchantName", "ARTWORK", "GameFontNormal")
  enchantIDName:SetPoint("LEFT", enchantIDInputBox, "RIGHT", 5, 0)
  enchantIDName:SetTextColor(0.0,1.0,0.0)
  index = index + 1
  
  -- Setup gems
  FantasyLootFrameSocket1.id = "gem1"
  FantasyLootFrameSocket2.id = "gem2"
  FantasyLootFrameSocket3.id = "gem3"
  FantasyLootFrameSocket4.id = "gem4"
  local gemMenuFrame = CreateFrame("Frame", "FantasyLootFrameGemMenu", FantasyLootFrame, "UIDropDownMenuTemplate")
  
  frame.numControls = index - 1
end

function FantasyLootUI:OnShow(frame)
	PlaySound("UI_EtherealWindow_Open")
	FantasyLootUI:Update(frame)
end

function FantasyLootUI:OnHide(frame)
	PlaySound("UI_EtherealWindow_Close")
	FantasyLootUI:HideControls()
	FantasyLootFrameSocket1:Hide()
	FantasyLootFrameSocket2:Hide()
	FantasyLootFrameSocket3:Hide()
	FantasyLootFrameSocket4:Hide()
  
  FantasyLoot:Hide()
end

function FantasyLootUI:Update(frame)
  local i = FantasyLoot.item
	local id = i.id
	
	local FantasyLootFrame = FantasyLootFrame
	if id then
		FantasyLootFrame.ItemButton.IconTexture:SetTexture(GetItemIcon(id))
		FantasyLootFrame.ItemButton.IconTexture:SetTexCoord( 0, 1, 0, 1)
		FantasyLootFrame.ItemButton.ItemName:SetText("|cff"..i.color..i.name.."|r")
		FantasyLootFrame.ItemButton.SubItemText:Show()
		FantasyLootFrame.ItemButton.MissingText:Hide()	
		FantasyLootFrame.MissingDescription:Hide()
		FantasyLootFrame.MissingFadeOut:Hide()
		FantasyLootFrame.TitleTextLeft:Show()
		FantasyLootFrame.TitleTextRight:Show()
		FantasyLootFrame.TitleTextMiddle:Show()
    FantasyLootFrame.TitleTextBottom:Show()
		FantasyLootFrame.HorzBar:Show()
    FantasyLootFrame.HorzBar2:Show()
    FantasyLootFrameSocket1:Show()
    FantasyLootFrameSocket2:Show()
    FantasyLootFrameSocket3:Show()
    FantasyLootFrameSocket4:Show()
    FantasyLootFrameSocket1Right:Hide();
		FantasyLootFrameSocket2Left:Show();
		FantasyLootFrameSocket2Right:Hide();
		FantasyLootFrameSocket3Left:Show();
		FantasyLootFrameSocket3Right:Hide();
    FantasyLootFrameSocket4Left:Show();
		FantasyLootFrameSocket4Right:Show();
		FantasyLootFrameSocket1:SetPoint("BOTTOM", FantasyLootFrame, "BOTTOM", -120, 38);
		
		FantasyLootUI:UpdateControls() -- Inline this?
	else	-- There is no item so hide elements
		FantasyLootFrame.ItemButton.IconTexture:SetTexture("Interface\\BUTTONS\\UI-Slot-Background")
		FantasyLootFrame.ItemButton.IconTexture:SetTexCoord( 0, 0.640625, 0, 0.640625)
		FantasyLootFrame.ItemButton.ItemName:SetText("")
    FantasyLootFrame.ItemButton.SubItemText:Hide()
		FantasyLootFrame.ItemButton.MissingText:Show()	
		FantasyLootFrame.MissingDescription:Show()
		FantasyLootFrame.MissingFadeOut:Show()
		FantasyLootFrame.TitleTextLeft:Hide()
		FantasyLootFrame.TitleTextRight:Hide()
    FantasyLootFrame.TitleTextMiddle:Hide()
		FantasyLootFrame.TitleTextBottom:Hide()
		FantasyLootFrame.HorzBar:Hide()
    FantasyLootFrame.HorzBar2:Hide()
		FantasyLootUI:HideControls()
    FantasyLootFrameSocket1:Hide()
    FantasyLootFrameSocket2:Hide()
    FantasyLootFrameSocket3:Hide()
    FantasyLootFrameSocket4:Hide()
	end
end

function FantasyLootUI:OnItemClick(frame, button)
  local itemLink = FantasyLoot:GetItem()
  if itemLink and button == "RightButton" then
    FantasyLoot:ClearItem()
    FantasyLootUI:Update(frame)
    GameTooltip:Hide()
    return
  elseif itemLink and IsModifiedClick() then
    if HandleModifiedItemClick(itemLink) then
      return
    end
  end
  if CursorHasItem() then --Recieve drag, or click while cursor item
    FantasyLoot:SetItem(select(3,GetCursorInfo()))
    ClearCursor()
    FantasyLootUI:Update(frame)
  end
end

function FantasyLootUI:OnEnterGem(frame)
  GameTooltip:SetOwner(frame, "ANCHOR_RIGHT")
  if (frame.text) then
    GameTooltip:AddLine(frame.type)
    GameTooltip:AddLine("|cffffffff"..frame.text)
    GameTooltip:AddLine(L["<Left-Click To Change Gem>"])
    GameTooltip:AddLine(L["<Right-Click To Remove>"])
  else
    GameTooltip:AddLine(frame.type)
    GameTooltip:AddLine(L["<Left-Click To Add Gem>"])
  end
  GameTooltip:Show();
end

function FantasyLootUI:OnGemClick(frame, button)
  if button == "RightButton" then
    FantasyLoot:DeltaApply(frame.id, 0)
    if frame.text then
      FantasyLootUI:Update(FantasyLootFrame)
    end
  elseif button == "LeftButton" then
    FantasyLootUI.lastGem = frame.id
    EasyMenu(FantasyLootUI.gemMenu, FantasyLootFrameGemMenu, "cursor", 0, 0, "MENU", 3)
  end
end

local function ClearMenu(tab)
  for k in pairs(tab) do tab[k]=nil end
end

function FantasyLootUI:DeltaUpdate(key, value)
  local playAnim = false
  if key == "reforgeA" then
    local dropdown = FantasyLootFrameControl2DropDown
    if value == 0 then
      UIDropDownMenu_SetText(dropdown, "No Reforge")
      UIDropDownMenu_DisableDropDown(dropdown)
    else
      ClearMenu(dropdown.menu)
      for v,k in ipairs(indexToStatInfo) do
        if v ~= value then
          tinsert(dropdown.menu, { text = _G[k], arg1 = v, arg2 = "reforgeB" })
        end
      end
      dropdown.selected = nil
      UIDropDownMenu_EnableDropDown(dropdown)
      UIDropDownMenu_SetText(dropdown, CHOOSE)
    end
  elseif key == "reforgeB" then
    playAnim = true
  elseif key == "upgradeT" then
    local dropdown = FantasyLootFrameControl4DropDown
    if value == 0 then
      UIDropDownMenu_SetText(dropdown, "No Upgrade")
      UIDropDownMenu_DisableDropDown(dropdown)
    else
      ClearMenu(dropdown.menu)
      local level = 0
      local maxuid = 0
      local utype = upgradeByType[value]
      if utype.start ~= nil then
        for uid = utype.start, utype.start + utype.levels do
          tinsert(dropdown.menu, { text = level.."/"..utype.levels, arg1 = uid, arg2 = "upgradeID" })
          maxuid = uid
          level = level + 1
        end
      else
        for _, v in ipairs(utype) do
          for uid = v.start, v.start + v.levels do
            tinsert(dropdown.menu, { text = level.."/"..utype.levels, arg1 = uid, arg2 = "upgradeID" })
            maxuid = uid
            level = level + 1
          end
        end
      end
      dropdown.selected = utype.levels.."/"..utype.levels
      UIDropDownMenu_EnableDropDown(dropdown)
      UIDropDownMenu_SetText(dropdown, dropdown.selected)
      FantasyLoot:DeltaApply("upgradeID", maxuid)
      playAnim = true
    end
  elseif key == "upgradeID" then
    playAnim = true
  end
  if playAnim then
    FantasyLootFrame.FinishedGlow.FinishedAnim:Play()
  end
end

function FantasyLootUI:UpdateControls()
  local control, dropdown
  local i = FantasyLoot.item
  local prefix = "FantasyLootFrameControl"
  local index = 1
  -- Print reforge left
    -- Reforge from: No reforge (disable menu 2), reforgestat1, etc
    -- Reforge to: [reforge targets]
  control = _G[prefix..index]
  dropdown = _G[prefix..index.."DropDown"]
  local stats = GetItemStats(FantasyLoot:GetItem())
  local reforge = FantasyLoot:GetItemReforgeStats()
  ClearMenu(dropdown.menu)
  tinsert(dropdown.menu, { text = L["No Reforge"], arg1 = 0, arg2 = "reforgeA" })
  for k in pairs(stats) do
    if statInfoToIndex[k] then
      tinsert(dropdown.menu, { text = _G[k], arg1 = statInfoToIndex[k], arg2 = "reforgeA" })
    end
  end
  if not reforge then
    dropdown.selected = "No Reforge"
  else
    dropdown.selected = _G[indexToStatInfo[reforge[1]]]
  end
  UIDropDownMenu_SetText(dropdown, dropdown.selected)
  control:Show()
  index = index + 1
  
  control = _G[prefix..index]
  dropdown = _G[prefix..index.."DropDown"]
  if not reforge then
    UIDropDownMenu_SetText(dropdown, L["No Reforge"])
    UIDropDownMenu_DisableDropDown(dropdown)
  else
    ClearMenu(dropdown.menu)
    for v,k in ipairs(indexToStatInfo) do
      if v ~= ((reforge and reforge[1]) or 0) then
        tinsert(dropdown.menu, { text = _G[k], arg1 = v, arg2 = "reforgeB" })
      end
    end
    dropdown.selected = _G[indexToStatInfo[reforge[2]]]
    UIDropDownMenu_EnableDropDown(dropdown)
    UIDropDownMenu_SetText(dropdown, dropdown.selected)
  end
  control:Show()
  index = index + 1
  
  -- Print upgrade right
    -- Upgrade type: [jp,vp,hp,cp,unk]
    -- Upgrade level: [0/2, 1/2, 2/2] etc
  control = _G[prefix..index]
  dropdown = _G[prefix..index.."DropDown"]
  local upgrade = FantasyLoot:GetItemUpgrade()
  ClearMenu(dropdown.menu)
  tinsert(dropdown.menu, { text = L["No Upgrade"], arg1 = 0, arg2 = "upgradeT" })
  for _,k in ipairs(upgradeByType) do
    tinsert(dropdown.menu, { text = L[k], arg1 = k, arg2 = "upgradeT" })
  end
  dropdown.selected = upgrade or L["No Upgrade"]
  UIDropDownMenu_SetText(dropdown, dropdown.selected)
  control:Show()
  index = index + 1
  
  control = _G[prefix..index]
  dropdown = _G[prefix..index.."DropDown"]
  if not upgrade then
    UIDropDownMenu_SetText(dropdown, "No Upgrade")
    UIDropDownMenu_DisableDropDown(dropdown)
  else
    ClearMenu(dropdown.menu)
    local level = 0
    local curlevel = 0
    local utype = upgradeByType[upgrade]
    if utype.start ~= nil then
      for uid = utype.start, utype.start + utype.levels do
        tinsert(dropdown.menu, { text = level.."/"..utype.levels, arg1 = uid, arg2 = "upgradeID" })
        if uid == tonumber(i.upgrade) then
          curlevel = level
        end
        level = level + 1
      end
    else
      for _, v in ipairs(utype) do
        for uid = v.start, v.start + v.levels do
          tinsert(dropdown.menu, { text = level.."/"..utype.levels, arg1 = uid, arg2 = "upgradeID" })
          if uid == tonumber(i.upgrade) then
            curlevel = level
          end
          level = level + 1
        end
      end
    end
    dropdown.selected = curlevel.."/"..utype.levels
    UIDropDownMenu_EnableDropDown(dropdown)
    UIDropDownMenu_SetText(dropdown, dropdown.selected)
  end
  control:Show()
  index = index + 1
  
  -- Print enchants
  control = _G[prefix..index]
  dropdown = _G[prefix..index.."InputBox"]
  dropdown:SetText(i.enchant)
  FantasyLootFrameControl5EnchantName:SetText(FantasyLoot:GetEnchantName(i.enchant))
  control:Show()
  index = index + 1
  
  -- Do gems
  local bracketsOpen, gemColor, gemInfo, gemBorder, socket, socketName, socketType, closedBracket, openBracket
  local gems = {}
  FantasyLootScanningTooltip:ClearLines()
  FantasyLootScanningTooltip:SetHyperlink(select(2,GetItemInfo(i.id)))
  for j = 1, 4 do
    socket = _G["FantasyLootScanningTooltipTexture"..j]
    if socket:IsShown() then
      socketName = select(2,socket:GetPoint()):GetText()
      for k,v in pairs(gemKeys) do
        if socketName == _G[k] then
          tinsert(gems, {name = _G[k], color = v})
          break
        end
      end
    else
      break
    end
  end
  --[[ Old method, order not guaranteed
  for k in pairs(stats) do
    if gemKeys[k] then
      tinsert(gems, {name = _G[k], color = gemKeys[k]})
    end
  end
  ]]
  for j = 1, 4 do -- 4 = max gems
    gemColor = (gems[j] and gems[j].color) or "Prismatic"
    socketType = (gems[j] and gems[j].name) or EMPTY_SOCKET_PRISMATIC
    socketName = "FantasyLootFrameSocket"..j
    socket = _G[socketName]
    socket.type = socketType
    closedBracket = _G[socketName.."BracketFrameClosedBracket"]
		openBracket = _G[socketName.."BracketFrameOpenBracket"]
    gemInfo = GEM_TYPE_INFO[gemColor]
    text, icon = FantasyLoot:GetItemSocketInfo(j)
    bracketsOpen = 1
    if icon then
      bracketsOpen = nil
      socket.text = text
      AnimatedShine_Start(socket, gemInfo.r, gemInfo.g, gemInfo.b)
    else
      socket.text = nil
      AnimatedShine_Stop(socket)
    end
    if bracketsOpen then
      -- Show open brackets
      closedBracket:Hide();
      openBracket:Show();
    else
      -- Show closed brackets
      closedBracket:Show();
      openBracket:Hide();
    end
    if ( gemColor ~= "" ) then
      gemBorder = _G[socketName.."Background"]
      gemBorder:SetTexture(gemInfo.tex);
      gemBorder:SetWidth(gemInfo.w);
      gemBorder:SetHeight(gemInfo.h);
      gemBorder:SetTexCoord(gemInfo.left, gemInfo.right, gemInfo.top, gemInfo.bottom);
      gemBorder:Show();
      if ( gemColor == "Meta" ) then
        -- Special stuff for meta gem sockets
        SetDesaturation(openBracket, 1);
        SetDesaturation(closedBracket, 1);
      else
        SetDesaturation(openBracket, nil);
        SetDesaturation(closedBracket, nil);
      end
      openBracket:SetSize(gemInfo.OBx, gemInfo.OBy);
      openBracket:SetTexture(gemInfo.tex);
      openBracket:SetTexCoord(gemInfo.OBLeft, gemInfo.OBRight, gemInfo.OBTop, gemInfo.OBBottom);
      closedBracket:SetSize(gemInfo.CBx, gemInfo.CBy)
      closedBracket:SetTexture(gemInfo.tex);
      closedBracket:SetTexCoord(gemInfo.CBLeft, gemInfo.CBRight, gemInfo.CBTop, gemInfo.CBBottom);
      if ( ENABLE_COLORBLIND_MODE == "1" ) then
        gemColorText = _G[socketName.."Color"];
        gemColorText:SetText(_G[strupper(gemColor) .. "_GEM"]);
        gemColorText:Show();
      else
        _G[socketName.."Color"]:Hide();
      end
    else
      gemBorder:Hide();
    end

    SetItemButtonTexture(socket, icon);
  end
  
end

function FantasyLootUI:HideControls()
  for i = 1, FantasyLootFrame.numControls do
    _G["FantasyLootFrameControl"..i]:Hide()
  end
end
